unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Buttons, ExtCtrls, Menus, UnitScore, about;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Game1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    New1: TMenuItem;
    HiScore1: TMenuItem;
    Pause1: TMenuItem;
    Ipozadie: TImage;
    settings1: TMenuItem;
    set1: TMenuItem;
    set2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure New1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Pause1Click(Sender: TObject);
    procedure HiScore1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure set1Click(Sender: TObject);
    procedure set2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
   fOdstranenie = $2698FF;
   fPozadie : array[0..5] of TColor = ($0C00BF,$CE0030,$1E9F00,$A89304,$B50000,$00A59F);
   tRychlovka = 50;


type
  TDirection = (dLeft,dRight);

  tSquare = class(TObject)
  public
     color : TColor;
     desing :TBitmap;
     exist : boolean;
     constructor create(Aowner :TComponent);
     destructor destroy; override;

     procedure assign(source :TSquare);
  end;

  TPole = array[0..9,-4..19] of tSquare;

  TShape = array[0..3,0..3] of boolean;

  TSpoloha = record
             x:-3..8;
             y:-4..19;
  end;

  TDesktop = class(TDrawGrid)
    public
      pole :Tpole;
      kto :1..2;
      constructor Create(AOwner: TComponent; _ColCount, _RowCount, _top, _left :integer);
      destructor destroy; override;

      function zapis :boolean; //vrati false ak sa blok nezmestil na plochu - co vyvola gameover
      procedure DrawDesktop;
      procedure DrawBlock(zobraz:boolean);
      procedure uprac;
      procedure prekresli(Sender: TObject; ACol, ARow: Integer; ARect: TRect; State: TGridDrawState);
      procedure vymaz;
    end;

  TBlock = class(TObject)
    private
      Spoloha :tSpoloha;
      function canMove(rx,ry:integer):boolean;
      function canBe(pomShape:TShape):boolean;
      procedure rotateDesing(dir :TDirection);
    public
      color :tColor;
      desing :TBitmap;
      shape :tShape;
      constructor Create(AOwner: TObject);
      destructor destroy; override;

      procedure assign(source :TBlock);
      property poloha: tsPoloha read sPoloha write sPoloha;
      procedure Move(rx,ry:integer);
      procedure Land;
      procedure Rotate(dir :TDirection);
    end;

  tHra = class(TObject)
    private
      Slevel,Sscore,SRychlost:integer;
      Desktop, Preview :TDesktop;
      ActivBlock, PassivBlock :TBlock;
      cas :integer;

      Timer :TTimer;
      TimerCas :TTimer;
      BStart :TButton;
      Lscore :TLabel;
      LLevel :TLabel;
      LGameOver :TLabel;
      LHiScore :TLabel;
      LCas :TLabel;

      procedure zmenLevel(i:integer);
      procedure Zmenscore(i:integer);
      procedure ZmenRychlost(i:integer);
      procedure NacitajDizajn;

      procedure OnCas(Sender: TObject);
      procedure OnTick(Sender: TObject);
    public
      desing :array[0..9] of TBitmap;
      stav :boolean;  //true bezi, inak false;
      farbaPozadia :integer;

      property level:integer read Slevel write ZmenLevel;
      property score:integer read Sscore write Zmenscore;
      property rychlost:integer read SRychlost write ZmenRychlost;

      constructor Create(AOwner: TObject);
      destructor destroy; override;
      procedure GameOver;
      procedure initGame(Sender: TObject);
      procedure pause;
    end;

var
  Form1 :TForm1;
  Hra :tHra;

implementation

{$R *.dfm}

procedure THra.OnTick(Sender: TObject);
begin
    hra.ActivBlock.Move(0,1);
end;

procedure THra.OnCas(Sender: TObject);
begin
    inc(cas);
    LCas.Caption := 'Cas: '+Format('%2.2d:%2.2d',[cas div 60,cas mod 60]);
    if cas mod 60 = 0 then level := level+1;
end;

Constructor THra.Create(AOwner: Tobject);
var i :integer;
begin
    inherited create;
    stav := false;
    cas := 0;

    for i := 0 to 9 do desing[i] := TBitmap.Create;

    NacitajDizajn;

    farbaPozadia := random(6);

    Desktop := TDesktop.Create(form1, 10,20,50,50);
    Preview := TDesktop.Create(form1, 4,4,50,300);

//    ActivBlock := TBlock.Create(self);
//    PassivBlock := TBlock.Create(self);

    timer := TTimer.Create(form1);
    timer.Interval := 100;
    timer.OnTimer := OnTick;
    timer.Enabled := false;

    timerCas := TTimer.Create(form1);
    timerCas.Interval := 1000;
    timerCas.OnTimer := OnCas;
    timerCas.Enabled := false;

    form1.Height := 637;
    form1.Width := 450;

    BStart := TButton.Create(form1);
    with Bstart do begin
        Parent := Form1;
        Left := 300;
        Top := 275;
        Width := 100;
        Height := 25;
        Caption := 'Start';
        TabOrder := 0;
        OnClick := initGame;
    end;

    Lscore := TLabel.Create(form1);
    with Lscore do begin
        Parent := Form1;
        Left := 300;
        Top := 200;
        Width := 58;
        Height := 16;
        Caption := 'Score: 0';
        Font.Charset := DEFAULT_CHARSET;
        Font.Color := clWindowText;
        Font.Height := -13;
        Font.Name := 'MS Sans Serif';
        Font.Style := [fsBold];
        ParentFont := False;
    end;

    LHiScore := TLabel.Create(form1);
    with LhiScore do begin
        Parent := Form1;
        Left := 300;
        Top := 215;
        Width := 58;
        Height := 16;
        Caption := 'HiScore: '+inttostr(TabulkaScore.HiScore.score);
        Font.Charset := DEFAULT_CHARSET;
        Font.Color := clWindowText;
        Font.Height := -13;
        Font.Name := 'MS Sans Serif';
        Font.Style := [fsBold];
        ParentFont := False;
    end;


    LLevel := TLabel.Create(form1);
    with LLevel do begin
        Parent := Form1;
        Left := 300;
        Top := 175;
        Width := 58;
        Height := 16;
        Caption := 'Level: 1';
        Font.Charset := DEFAULT_CHARSET;
        Font.Color := clWindowText;
        Font.Height := -13;
        Font.Name := 'MS Sans Serif';
        Font.Style := [fsBold];
        ParentFont := False;
    end;

    LCas := TLabel.Create(form1);
    with LCas do begin
        Parent := Form1;
        Left := 300;
        Top := 160;
        Width := 58;
        Height := 16;
        Caption := 'Cas: 00:00';
        Font.Charset := DEFAULT_CHARSET;
        Font.Color := clWindowText;
        Font.Height := -13;
        Font.Name := 'MS Sans Serif';
        Font.Style := [fsBold];
        ParentFont := False;
    end;


    LGameOver := TLabel.Create(form1);
    with LGameOver do begin
        Parent := Form1;
        Left := 300;
        Top := 250;
        Width := 58;
        Height := 16;
        Caption := 'Game Over';
        Font.Charset := DEFAULT_CHARSET;
        Font.Color := clWindowText;
        Font.Height := -13;
        Font.Name := 'MS Sans Serif';
        Font.Style := [fsBold];
        ParentFont := False;
        visible := false;
    end;
end;

procedure THra.NacitajDizajn;
var i:integer;
begin
    for i := 0 to 9 do begin
       desing[i] := TBitmap.Create;
       if Form1.set1.Checked then desing[i].LoadFromFile('./images/square1'+inttostr(i)+'.bmp')
       else desing[i].LoadFromFile('./images/square0'+inttostr(i)+'.bmp');
    end;
end;

destructor THra.destroy;
var i:integer;
begin
    for i := 0 to 9 do  desing[i].Destroy;
    Desktop.destroy;
    Preview.destroy;
    ActivBlock.destroy;
    PassivBlock.destroy;

    timer.Destroy;
    BStart.Destroy;

    Lscore.Destroy;
    LLevel.Destroy;
    LGameOver.Destroy;

    inherited destroy;
end;

procedure THra.initGame(Sender: TObject);
begin
    hra.activBlock := TBlock.Create(hra);
    hra.PassivBlock := TBlock.Create(hra);
    farbaPozadia := random(6);

    desktop.vymaz;
    cas := 0;

    BStart.Enabled:=false;
    LgameOver.Visible:=false;
    Level:=1;
    score:=0;

    Preview.DrawDesktop;
    Preview.DrawBlock(true);
    Desktop.DrawDesktop;
    Desktop.DrawBlock(true);

    stav := true;
    timer.Enabled := true;
    TimerCas.Enabled := true;
end;

procedure THra.GameOver;
begin
    stav := false;
    timer.Enabled := false;
    TimerCas.Enabled := false;
    LGameOver.Visible := true;
    TabulkaScore.zapisScore(score);
    LHiScore.Caption := 'HiScore: '+inttostr(TabulkaScore.HiScore.score);
    BStart.Enabled := true;
    BStart.SetFocus;
    hra.ActivBlock.destroy;
    hra.PassivBlock.destroy;
end;

procedure THra.Zmenscore(i:integer);
begin
   Sscore := i;
   Lscore.Caption := 'Score: '+inttostr(Sscore);
//   if level < (i div 1000)+1 then level := level+1; //tu sa menil level podla skore za 1000 bodov +level
end;

procedure THra.zmenLevel(i:integer);
var r:integer;
begin
   SLevel := i;
   LLevel.Caption := 'Level: '+inttostr(Level);
   Rychlost := round(600*exp(-level/5));

   if i > 1 then begin
      repeat r := random(6);
      until r <> farbaPozadia;
      farbaPozadia := r;

      Desktop.DrawDesktop;
      Desktop.DrawBlock(true);
      Preview.DrawDesktop;
      Preview.DrawBlock(true);
   end;
end;

procedure THra.ZmenRychlost(i:integer); begin
   SRychlost := i;
   timer.Interval := i;
end;

constructor TDesktop.Create(AOwner: TComponent; _ColCount, _RowCount, _top, _left :integer);
var x,y :integer;
begin
    inherited Create(AOwner);
    Parent:=Form1;
    left := _left;
    top := _top;
    GridLineWidth:=0;
    Width := 24*_ColCount+4;
    Height := 24*_RowCount+4;
    FixedCols := 0;
    FixedRows := 0;
    DefaultColWidth := 24;
    DefaultRowHeight := 24;
    ColCount := _ColCount;
    RowCount := _RowCount;
    TabStop := false;
    Enabled := false;

    OnDrawCell := prekresli;

    if _RowCount > 4 then kto := 1
    else kto := 2;

    for x := 0 to 9 do
      for y := -4 to 19 do
        pole[x,y] := TSquare.create(self);
end;

destructor TDesktop.destroy;
var x, y :integer;
begin
    for x := 0 to 9 do
      for y := -4 to 19 do
        pole[x,y].destroy;
    inherited destroy;
end;

procedure TDesktop.vymaz;
var x, y:integer;
begin
    for x:=0 to 9 do
       for y:=-4 to 19 do
          pole[x,y].exist:=false;
end;

constructor TSquare.create(AOwner :Tcomponent);
begin
    inherited create();
    exist := false;
    desing := TBitmap.Create;
    desing.Height:=24;
    desing.Width:=24;
    color := 0;
end;

destructor TSquare.destroy;
begin
    desing.destroy;
    inherited destroy;
end;

procedure TSquare.assign(source :TSquare);
begin
     exist := source.exist;
     color := source.color;
     desing.Assign(source.desing);
end;

procedure TDesktop.prekresli(Sender: TObject; ACol, ARow: Integer; ARect: TRect; State: TGridDrawState);
var x,y:integer;
begin
    x := Acol;
    y := Arow;
    if pole[x,y].exist then Canvas.CopyRect(CellRect(x,y),pole[x,y].desing.Canvas,Rect(0,0,24,24))
    else begin
        Canvas.Brush.Color:=fPozadie[hra.farbaPozadia];
        Canvas.FillRect(CellRect(x,y));
    end;
end;

procedure TDesktop.DrawDesktop;
begin
    Repaint;
end;

procedure TDesktop.DrawBlock(zobraz:boolean);
var i,j :integer;
    pomBlock:TBlock;
    kx,ky:integer;
    pomRect:TRect;
begin
    if kto = 1 then begin
       pomBlock := hra.ActivBlock;
       kx := 0; ky := 0;
    end else begin
       pomBlock := hra.PassivBlock;
       kx := -4; ky := +3;
    end;

    if zobraz then Canvas.Brush.Color := pomBlock.color
    else Canvas.Brush.Color := fPozadie[hra.farbaPozadia];
    for i:=0 to 3 do
       for j:=0 to 3 do
           if (pomBlock.shape[i,j]) and (j+pomBlock.poloha.y + ky >= 0) then
              if not zobraz then Canvas.FillRect(CellRect(i+pomBlock.poloha.x + kx,j+pomBlock.poloha.y + ky))
              else begin
               pomRect:=CellRect(i+pomBlock.poloha.x + kx,j+pomBlock.poloha.y + ky);
               Canvas.CopyRect(pomRect,pomBlock.desing.Canvas,Rect(0,0,24,24));
               end;
end;

function TDesktop.zapis :boolean;
var i,j:integer;
begin
    result := true;
    for i:=0 to 3 do
       for j:=0 to 3 do
           if hra.ActivBlock.shape[i,j] then begin
                pole[i+hra.ActivBlock.poloha.x,j+hra.ActivBlock.poloha.y].exist:=true;
                pole[i+hra.ActivBlock.poloha.x,j+hra.ActivBlock.poloha.y].color:=hra.ActivBlock.color;
                pole[i+hra.ActivBlock.poloha.x,j+hra.ActivBlock.poloha.y].desing.Assign(hra.ActivBlock.desing);
                if j+hra.ActivBlock.poloha.y < 0 then result := false;
           end;
    if result then uprac;
end;

procedure TDesktop.uprac;
var x, y, xx, yy :integer;
    i,l :integer;
    treba :boolean;
    odstranit :array[1..5] of integer;
begin
   Hra.timer.Enabled:=false; //pozastavi hru do skoncenia upratovania

   //najde riadky ktore treba odstranit
   i:=0;
   for y:=0 to 19 do begin
     treba:=true;
     for x:=0 to 9 do begin
         if not pole[x,y].exist then treba:=false;
     end;
     if treba then begin
        inc(i);
        odstranit[i]:=y;
     end;
   end;

   //ak nie je co odsranit mozem vyskocit
   if i=0 then begin
      DrawDesktop;
      Hra.timer.Enabled:=true;
      exit;
   end;

   //vysvieti riadky na odstranenie
   for y:=1 to i do
       for x:=0 to 9 do begin
           for xx:=0 to 23 do
               for yy:=0 to 23 do begin
                   //stara :=
                   pole[x,odstranit[y]].desing.Canvas.Pixels[xx,yy] := //fOdstranenie;
//                   r := (stara and $0000FF);
//                   g := (stara and $00FF00) shr 8;
 //                  b := (stara and $FF0000) shr 16;
                   pole[x,odstranit[y]].desing.Canvas.Pixels[xx,yy] and fOdstranenie;
               end;
       end;

   //pauza 500ms
   DrawDesktop;
   Sleep(400);

   //uprace plochu po odstraneni
   for l:=1 to i do begin
     for y:=odstranit[l]-1 downto 0 do
       for x:=0 to 9 do pole[x,y+1].assign(pole[x,y]);
       for x:=0 to 9 do pole[x,0].exist:=false;
   end;

   DrawDesktop;
   Hra.score:=Hra.score + i*i*50;
   Hra.timer.Enabled:=true;
end;

destructor TBlock.destroy;
begin
    desing.Destroy;
    inherited destroy;
end;

constructor TBlock.Create(AOwner: TObject);
var i,j:integer;
    r:integer;
    a:TSPoloha;
begin
    //vylosuje sa aky bude mat tvar a farbu
    inherited Create;

//    color :=random(60000);
    desing := TBitmap.Create;
    desing.Assign((AOwner as Thra).desing[random(10)]);

    for i:=0 to 3 do
      for j:=0 to 3 do shape[i,j]:=false;

    a.x:=4;
    a.y:=-3;
    poloha:=a;

    r := random(13);
    case r of
 {x..}  0,1: begin
 {xxx}      shape[0,1]:=true; shape[1,1]:=true; shape[2,1]:=true; shape[0,2]:=true;
        end;
 {xxx}  2,3: begin
 {..x}      shape[0,1]:=true; shape[1,1]:=true; shape[2,1]:=true; shape[2,2]:=true;
        end;
 {xx.}  4,5: begin
 {.xx}      shape[0,1]:=true; shape[1,1]:=true; shape[1,2]:=true; shape[2,2]:=true;
        end;
 {.xx}  6,7: begin
 {xx.}      shape[0,2]:=true; shape[1,1]:=true; shape[1,2]:=true; shape[2,1]:=true;
        end;
 {.x.}  8,9,10: begin
 {xxx}      shape[1,1]:=true; shape[0,2]:=true; shape[1,2]:=true; shape[2,2]:=true;
        end;
 {xx}   11: begin
 {xx}       shape[1,1]:=true; shape[1,2]:=true; shape[2,1]:=true; shape[2,2]:=true;
        end;
 {xxxx} 12: begin
            shape[0,1]:=true; shape[1,1]:=true; shape[2,1]:=true; shape[3,1]:=true;
        end;
    end;
end;

procedure TBlock.assign(source :TBlock);
begin
    Spoloha := source.Spoloha;
    color := source.color;
    desing.Assign(source.desing);
    shape := source.shape;
end;

function TBlock.canBe(pomShape:TShape):boolean;
var i,j:integer;
begin
    for i:=0 to 3 do
      for j:=0 to 3 do
        if (pomShape[i,j] and
           ( (i+poloha.x < 0) or (i+poloha.x > 9) or (j+poloha.y < -4) or (j+poloha.y > 19)
              or hra.desktop.pole[i+poloha.x,j+poloha.y].exist)) then begin
               canBe :=false;
               exit;
        end;

    canBe := true;
end;

procedure TBlock.Rotate(dir :TDirection);
var pomShape:TShape;
    i,j:integer;
begin
   for i:=0 to 3 do
      for j:=0 to 3 do begin
          if dir = dleft then pomshape[i,j] := shape[3-j,i]
          else pomshape[3-j,i] := shape[i,j];
      end;

   if canBe(pomShape) then begin
       hra.Desktop.DrawBlock(false);
       shape:=pomshape;
       rotateDesing(dir);
       hra.Desktop.DrawBlock(true);
   end;
end;

//// nefunguje neviem preco :((((((((((((((((((((((((((((((((((((((((((((((((

procedure TBlock.rotateDesing(dir :TDirection);
var pom:TBitmap;
    i,j:integer;
begin
   pom := TBitmap.Create;
   pom.Width:=24;
   pom.Height:=24;
   for i:=0 to 23 do
      for j:=0 to 23 do begin
          if dir = dleft
            then pom.Canvas.Pixels[i,j] := desing.Canvas.Pixels[23-j,i]
            else pom.Canvas.Pixels[23-j,i] := desing.Canvas.Pixels[i,j];
      end;
   desing.Canvas.CopyRect(Rect(0,0,24,24),pom.Canvas,Rect(0,0,24,24));
   pom.Destroy;
end;

procedure TBlock.Land;
begin
    if not hra.desktop.zapis then begin
        hra.GameOver;
        exit;
    end;

    hra.Desktop.DrawDesktop;

    hra.activBlock.assign(hra.passivBlock);

    hra.PassivBlock.destroy;

    hra.PassivBlock := TBlock.Create(hra);

    hra.Preview.DrawDesktop;
    hra.preview.DrawBlock(true);
end;

function TBlock.canMove(rx,ry:integer): boolean;
var i,j:integer;
begin
    for i:=0 to 3 do
        for j:=0 to 3 do begin
            if (shape[i,j] and
            ( (i+poloha.x+rx < 0) or (i+poloha.x+rx > 9) or (j+poloha.y+ry < -4) or (j+poloha.y+ry > 19)
            or (hra.desktop.pole[i+poloha.x+rx,j+poloha.y+ry].exist) )   )
            then begin
               canMove:=false;
               exit;
            end;
        end;
    canMove:=true;
end;

procedure TBlock.Move(rx,ry:integer);
var a:TSpoloha;
begin
    if canMove(rx,ry) then begin
        hra.Desktop.DrawBlock(false);

        a.x:=poloha.x+rx;
        a.y:=poloha.y+ry;
        poloha:=a;

        if ry=1 then hra.score:=hra.score+2;

        hra.Desktop.DrawBlock(true);
    end
    else if ry=1 then Land;             // ked uz dopadol
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    DoubleBuffered:=true;
    randomize;

    TabulkaScore := tTabulkaScore.Create(self);
    hra := Thra.Create(self);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key = 80 then hra.pause;
    if hra.Timer.Enabled then
      case key of
        17: hra.ActivBlock.Rotate(dright);
        38: hra.ActivBlock.Rotate(dleft);
        37: hra.ActivBlock.Move(-1,0); //dolava?
        39: hra.ActivBlock.Move(1,0);  //doprava?
        40: hra.timer.Interval:=tRychlovka; //hra.ActivBlock.Move(0,1);  //dole?
        27: application.Terminate;                         {esc = halt}
      end;
end;

procedure THra.pause; begin
   if stav then begin
        hra.Timer.Enabled := not hra.timer.Enabled;
        hra.TimerCas.Enabled:= not hra.TimerCas.Enabled;
   end;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState); begin
      case key of
        40: hra.Timer.Interval := hra.rychlost;
      end;
end;

procedure TForm1.New1Click(Sender: TObject); begin
        if Hra.stav then Hra.GameOver;
        hra.initGame(sender);
end;

procedure TForm1.Exit1Click(Sender: TObject); begin
        Application.Terminate;
end;

procedure TForm1.Pause1Click(Sender: TObject); begin
        Hra.pause;
end;

procedure TForm1.HiScore1Click(Sender: TObject);
begin
       TabulkaScore.ZobrazScore;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
       FAbout.ShowModal;
end;

procedure TForm1.set1Click(Sender: TObject);
begin
    set1.Checked := true;
    set2.Checked := false;
    Hra.NacitajDizajn;
end;

procedure TForm1.set2Click(Sender: TObject);
begin
    set1.Checked := false;
    set2.Checked := true;
    Hra.NacitajDizajn;
end;

end.
