unit UnitScore;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids;

type
  tScore = record
      meno:string[20];
      datum:TDateTime;
      score:integer;
  end;

  tTabulka = array[1..10] of tScore;

  TFscore = class(TForm)
      gTabulkaScore: TStringGrid;
      bClose: TButton;
      procedure bCloseClick(Sender: TObject);
  end;

  tTabulkaScore = class(Tobject)
    private
      naposledyScore:string;
      tabulka :tTabulka;
      function CitajHiScore :tScore;
    public
      property HiScore:tScore read CitajHiScore;

      constructor Create(AOwner: TComponent);
      procedure nacitajScore;
      procedure zapisScore(score:integer);
      procedure ZobrazScore;
  end;

var
  Fscore: TFscore;
  TabulkaScore: tTabulkaScore;

implementation

{$R *.dfm}

procedure tTabulkaScore.ZobrazScore;
var i:integer;
begin
    with Fscore do begin
        gTabulkaScore.Cells[0,0]:='Name';
        gTabulkaScore.Cells[1,0]:='Score';
        gTabulkaScore.Cells[2,0]:='Time';
        gTabulkaScore.Cells[3,0]:='Date';
        gTabulkaScore.ColWidths[0]:=150;
        gTabulkaScore.ColWidths[1]:=100;

        for i:=1 to 10 do begin
           gTabulkaScore.Cells[0,i]:=Tabulka[i].meno;
           gTabulkaScore.Cells[1,i]:=InttoStr(Tabulka[i].score);
           gTabulkaScore.Cells[2,i]:=timetostr(Tabulka[i].datum);
           gTabulkaScore.Cells[3,i]:=datetostr(Tabulka[i].datum);
        end;
    end;
    Fscore.ShowModal;                  /// tu sa to dosere
end;

procedure tTabulkaScore.nacitajScore;
var f:file of tTabulka;
    i:integer;
begin
  naposledyScore:='';
  assignFile(f,'HiScore.dat');
   if not FileExists('HiScore.dat') then begin
     rewrite(f);
         for i:=1 to 10 do begin
            Tabulka[i].meno:='Hydrant';
            Tabulka[i].score:=0;
            Tabulka[i].datum:=36526;
         end;
         write(f,Tabulka);
     closeFile(f)
   end else begin
          reset(f);
             read(f,Tabulka);
          closeFile(f);
       end;
end;

procedure tTabulkaScore.zapisScore(score:integer);
var f:file of tTabulka;
    i:integer;
    noveScore:tScore;
begin
    if Score > Tabulka[10].score then
       if InputQuery('New High Score!','Type your name',naposledyScore) then begin
           noveScore.meno:=Copy(naposledyScore,1,20);
           noveScore.score:=Score;
           noveScore.datum:=date+time;

           i:=9;
           while (i>0) and (noveScore.score > Tabulka[i].score) do begin
                Tabulka[i+1] := Tabulka[i];
                dec(i);
           end;
           Tabulka[i+1]:=noveScore;

           assignFile(f,'HiScore.dat');
           rewrite(f);
              write(f,Tabulka);
           closeFile(f);

           ZobrazScore;
       end;
end;

function tTabulkaScore.CitajHiScore :tscore;
begin
    result := tabulka[1];
end;

constructor tTabulkaScore.Create(AOwner: TComponent);
begin
    inherited Create();
    nacitajScore;
end;

procedure TFscore.bCloseClick(Sender: TObject);
begin
      Close;
end;

end.
